/*
 * CS1237.c
 *
 *  Created on: 2023312
 *      Author: Simgor
 */

#include "CS1237.h"

//׼ѹ
static float ref = 2.5;
static GPIO_InitTypeDef GPIO_InitStrtus;

static inline void CS1237_Delay()
{
    __IO char i = 100;
    while(--i);
}

static inline void CS1237_Clock()
{
    _CS1237_CLK_ResetBits();
    CS1237_Clock();
    _CS1237_CLK_SetBits();
    CS1237_Clock();
}

inline char CS1237_Ready()
{
    return _CS1237_SDA_ReadBits();
}

inline void CS1237_PowerUp()
{
    //ӵģʽл
    _CS1237_CLK_ResetBits();
    Delay_Us(10);
}

void CS1237_PowerDown()
{
    //ģʽ
    _CS1237_CLK_SetBits();
    //Delay_Us(100);
}

static inline void CS1237_Send(uint8_t data)
{
    char i;
    for(i = 0; i < 8; i++)
    {
        if(data & (1 << i))
            _CS1237_SDA_SetBits();
        else
            _CS1237_SDA_ResetBits();
        CS1237_Clock();
    }
}

static inline uint32_t CS1237_Read(char len)
{
    uint32_t data = 0;
    char i;
    _CS1237_Input();
    for (i = 0; i < len; i++)
    {
        CS1237_Clock();
        data <<= 1;
        if(_CS1237_SDA_ReadBits())
            data += 1;
    }
    return data;
}

void CS1237_Init(CS1237_InitTypedef* CS1237_InitStruct)
{
    _CS1237_CLK_RCC_FUN();
    _CS1237_SDA_RCC_FUN();

    GPIO_InitStrtus.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStrtus.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStrtus.GPIO_Pin = _CS1237_CLK_Pin;
    GPIO_Init(_CS1237_CLK_GPIOx, &GPIO_InitStrtus);

    GPIO_InitStrtus.GPIO_Pin = _CS1237_SDA_Pin;
    GPIO_Init(_CS1237_SDA_GPIOx, &GPIO_InitStrtus);

    CS1237_PowerUp();

    _CS1237_CLK_ResetBits();
    _CS1237_SDA_SetBits();
    _CS1237_SDA_ResetBits();

    _CS1237_Input();

    CS1237_Read(26);    //ǰ26ʱ
    _CS1237_Output();   //
    CS1237_Read(3);     //272829

    CS1237_Send(CS1237_Config_Write << 1);  //30~37

    CS1237_Send(CS1237_InitStruct->CS1237_REFO|
                CS1237_InitStruct->CS1237_Speed|
                CS1237_InitStruct->CS1237_PGA|
                CS1237_InitStruct->CS1237_Channel);//38~45

    _CS1237_Input();
    CS1237_Clock();

    if(CS1237_InitStruct->CS1237_REFO == CS1237_REFO_DISABLE)
        ref = 3.3;
    else
        ref = 2.5;
}

double CS1237_GetADC()
{
    int32_t data = 0;
    data = CS1237_Read(27);
    data = data & 0x0FFF;
    return data;
}
