/*
 * CS1237.h
 *
 *  Created on: 2023312
 *      Author: Simgor
 */

#ifndef _CS1237_h
#define _CS1237_h
#include "debug.h"

#define _CS1237_CLK_RCC_FUN()       RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE)
#define _CS1237_CLK_GPIOx           GPIOA
#define _CS1237_CLK_Pin             GPIO_Pin_5

#define _CS1237_SDA_RCC_FUN()       RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE)
#define _CS1237_SDA_GPIOx           GPIOA
#define _CS1237_SDA_Pin             GPIO_Pin_7

#define _CS1237_CLK_SetBits()       GPIO_SetBits(_CS1237_CLK_GPIOx, _CS1237_CLK_Pin)
#define _CS1237_CLK_ResetBits()     GPIO_ResetBits(_CS1237_CLK_GPIOx, _CS1237_CLK_Pin)

#define _CS1237_SDA_SetBits()       GPIO_SetBits(_CS1237_SDA_GPIOx , _CS1237_SDA_Pin)
#define _CS1237_SDA_ResetBits()     GPIO_ResetBits(_CS1237_SDA_GPIOx , _CS1237_SDA_Pin)

#define _CS1237_SDA_ReadBits()      GPIO_ReadInputDataBit(_CS1237_SDA_GPIOx, _CS1237_SDA_Pin)

#define _CS1237_Input()             {GPIO_InitStrtus.GPIO_Mode = GPIO_Mode_IPU;\
                                     GPIO_Init(_CS1237_SDA_GPIOx, &GPIO_InitStrtus);}
#define _CS1237_Output()            {GPIO_InitStrtus.GPIO_Mode = GPIO_Mode_Out_PP;\
                                     GPIO_Init(_CS1237_SDA_GPIOx, &GPIO_InitStrtus);}

#define CS1237_REFO_ENABLE      (1 << 6)
#define CS1237_REFO_DISABLE     (0)

#define CS1237_Speed_10Hz       (0)
#define CS1237_Speed_40Hz       (1 << 4)
#define CS1237_Speed_640Hz      (2 << 4)
#define CS1237_Speed_1280Hz     (3 << 4)

#define CS1237_PGA_1            (0)
#define CS1237_PGA_2            (1 << 2)
#define CS1237_PGA_64           (2 << 2)
#define CS1237_PGA_128          (3 << 2)

#define CS1237_Channel_A        (0)
#define CS1237_Channel_TEMP     (2)
#define CS1237_Channel_GND      (3)

#define CS1237_Config_Read      (0x56)
#define CS1237_Config_Write     (0x65)

typedef struct
{
    uint8_t CS1237_REFO;        /* ׼ѹ */
    uint8_t CS1237_Speed;       /* ADC */
    uint8_t CS1237_PGA;         /* ɱŴ */
    uint8_t CS1237_Channel;     /* ͨѡ */
}CS1237_InitTypedef;

char CS1237_Ready();
void CS1237_PowerDown();
void CS1237_PowerUp();
void CS1237_Init(CS1237_InitTypedef* CS1237_InitStruct);
double CS1237_GetADC();


#endif /* USER_CS1237_CS1237_H_ */
