/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2021/06/06
 * Description        : Main program body.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for 
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/

/*
 *@Note
 USART Print debugging routine:
 USART1_Tx(PA9).
 This example demonstrates using USART1(PA9) as a print debug port output.

*/

#include "debug.h"
#include "CS1237/CS1237.h"
/* Global typedef */

/* Global define */

/* Global Variable */


int main(void)
{
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();
    USART_Printf_Init(115200);
    printf("SystemClk:%d\r\n", SystemCoreClock);

    CS1237_InitTypedef CS1237_InitStruct;
    CS1237_InitStruct.CS1237_Channel = CS1237_Channel_A;
    CS1237_InitStruct.CS1237_PGA = CS1237_PGA_1;
    CS1237_InitStruct.CS1237_REFO = CS1237_REFO_ENABLE;
    CS1237_InitStruct.CS1237_Speed = CS1237_Speed_40Hz;

    CS1237_Init(&CS1237_InitStruct);
    Delay_Ms(2);
    double data = 0;
    while(1)
    {
        CS1237_PowerUp();
        while(!CS1237_Ready());
        data = CS1237_GetADC();
        printf("%g\r\n",data);
        Delay_Ms(100);
    }
}
